// ignore_for_file: unused_element
// ignore_for_file: unused_field
// ignore_for_file: unused_import
// ignore_for_file: unused_local_variable
// ignore_for_file: unused_shown_name

import 'dart:convert';
import 'dart:typed_data';

import 'package:shared_aws_api/shared.dart' as _s;
import 'package:shared_aws_api/shared.dart'
    show
        rfc822ToJson,
        iso8601ToJson,
        unixTimestampToJson,
        nonNullableTimeStampFromJson,
        timeStampFromJson;

export 'package:shared_aws_api/shared.dart' show AwsClientCredentials;

/// JSON payload
class JSONPayload {
  final _s.RestJsonProtocol _protocol;
  JSONPayload({
    required String region,
    _s.AwsClientCredentials? credentials,
    _s.AwsClientCredentialsProvider? credentialsProvider,
    _s.Client? client,
    String? endpointUrl,
  }) : _protocol = _s.RestJsonProtocol(
          client: client,
          service: _s.ServiceMetadata(
            endpointPrefix: 'JSONPayload',
          ),
          region: region,
          credentials: credentials,
          credentialsProvider: credentialsProvider,
          endpointUrl: endpointUrl,
        );

  Future<OutputShape> operationName0() async {
    final response = await _protocol.sendRaw(
      payload: null,
      method: 'POST',
      requestUri: '/',
      exceptionFnMap: _exceptionFns,
    );
    final $json = await _s.jsonFromResponse(response);
    return OutputShape(
      data: BodyStructure.fromJson($json),
      header: _s.extractHeaderStringValue(response.headers, 'X-Foo'),
    );
  }
}

class OutputShape {
  final BodyStructure? data;
  final String? header;

  OutputShape({
    this.data,
    this.header,
  });
}

class BodyStructure {
  final String? foo;

  BodyStructure({
    this.foo,
  });
  factory BodyStructure.fromJson(Map<String, dynamic> json) {
    return BodyStructure(
      foo: json['Foo'] as String?,
    );
  }
}

final _exceptionFns = <String, _s.AwsExceptionFn>{};
